'多元１次方程式のｿﾙﾊﾞｰ(ｶﾞｳｽ消去法)V16の標準ﾓｼﾞｭｰﾙ   ［作成］黒田英夫(2023/04)
Imports System.Drawing.Printing

Module LineEquaCom

    'V6での改良点・・・ｻﾌﾞﾙｰﾁﾝGausCalcをﾓｼﾞｭｰﾙ化
    'V7での改良点・・・汎用化に全面変更
    'V8での改良点・・・入力データファイル読み込みのエラー処理追加
    'V9での改良点・・・.NetFrameworkの指定バージョンを3.5から4に変更
    'V10での改良点・・・入力データファイルの先頭にプログラム名を追加
    '                   （データの読み違いを防止）
    'V11での改良点・・・実行形式をDebugモードからReleaseモードへ変更
    '                   （計算時間の大幅短縮）
    'V12での改良点・・・各画面でボタンを読みやすい色に改善
    'V13での改良点・・・Visual Basic 2017に変更
    'V14での改良点・・・プログラムファイルの文字コードをUTF-8に統一、
    '                   データファイルの文字コードをUTF-8に変更
    'V15での改良点・・・入力データのファイル印刷メニューを廃止
    '                   （文字コードによる不具合のため）
    'V16での改良点・・・フリーソフト化、VB2022に移行

    Public CalcRes$             '計算結果表示データ
    Public DirOpen$             '立ち上げ時のディレクトリー名
    Public Fm$                  '入力データのファイル名
    Public Fy$                  '計算結果のファイル名
    Public Title$               'タイトル

    Public Timst As Date        '計算開始時刻

    Public InOut As Integer     'ファイル入出力の種類（0:入力、1:出力）
    Public KdataBackup As Integer   '入力データのバックアップファイル作成（0:なし、1:有り）
    Public KdataChange As Integer   'データ変更の有無（0:なし、1:有り）
    Public Kindex As Integer    'ﾃｷｽﾄｱﾚｲのｲﾝﾃﾞｯｸｽ
    Public KnewUFileA As Integer    '最近使用ﾌｧｲﾙAの更新有無
    Public N As Integer         '変数の数（＝方程式の数）
    Public Nline As Integer     'ﾌｧｲﾙの行数

    Public ArrText As New ArrayList()

    Public UFileA(6) As String  '最近使用した入力ﾌｧｲﾙの保存配列

    Public Tf() As Single       '右辺ﾍﾞｸﾄﾙ、後で変数解が入る
    Public Tk(,) As Single      '係数行列

    Sub DfileInputU(ByVal fxx$)
        '入力ﾃﾞｰﾀﾌｧｲﾙの読み込み
        'UTF-8･･･BOMなし
        'fxx$･･･入力ﾌｧｲﾙ名
        'ii･･･ﾌｧｲﾙ番号
        Dim aa$
        Dim i, j As Integer

        Dim sr As New System.IO.StreamReader(fxx$)
        Dim dat() As String
        aa$ = sr.ReadLine
        dat = aa.Split(",")
        aa$ = dat(1)
        If aa$ <> "LineEqua" Then
            aa$ = "データファイルが違います！"
            MsgBox(aa$, 0, "データエラー")
            sr.Close()
            Exit Sub
        End If
        Title$ = sr.ReadLine
        aa$ = sr.ReadLine
        dat = aa.Split(",")
        N = dat(1)
        ReDim Tk(N, N), Tf(N)

        aa$ = sr.ReadLine
        aa$ = sr.ReadLine
        For i = 1 To N
            aa$ = sr.ReadLine
            dat = aa.Split(",")
            For j = 1 To N
                Tk(i, j) = dat(j)
            Next j
            Tf(i) = dat(N + 1)
        Next i
        sr.Close()

    End Sub

    Sub DfileOutU(ByVal fxx$)
        '入力ﾃﾞｰﾀﾌｧｲﾙへの書き出し
        'UTF-8･･･BOMなし
        'fxx$･･･入力ﾃﾞｰﾀﾌｧｲﾙ名
        Dim aa$
        Dim i, j As Integer

        Dim sw As New IO.StreamWriter(fxx$)
        aa$ = "プログラム名" + "," + "LineEqua"
        sw.WriteLine(aa$)
        sw.WriteLine(Title$)
        aa$ = "変数の数" + "," + Str(N)
        sw.WriteLine(aa$)

        sw.WriteLine("＜方程式データ＞")
        sw.WriteLine("行番号、各係数、右辺")
        For i = 1 To N
            aa$ = Str$(i)
            For j = 1 To N
                aa$ = aa$ + ",  " + Str(Tk(i, j))
            Next j
            aa$ = aa$ + ",   " + Str(Tf(i))
            sw.WriteLine(aa$)
        Next i
        sw.Close()
        aa$ = "データをファイルへ保存しました。"
        MsgBox(aa$, 0, "ファイル保存完了")

    End Sub

    Sub FileName(ByRef fxx$, ByRef fxb$)
        'ﾌｧｲﾙ名fxx$の拡張子なしの部分fxb$を取り出す
        Dim i As Integer
        i = InStr(fxx$, ".")
        If i > 0 Then
            fxb$ = Left$(fxx$, i - 1)
        Else
            fxb$ = fxx$
        End If
    End Sub

    Sub GausCalc(ByRef kh As Integer, ByVal nx As Integer, ByRef fmat(,) As Double, _
    ByRef cvec() As Double)
        '線形方程式のガウス消去法計算
        'kh･･･ｴﾗｰ有無（0:なし、-1:有り）
        'nx･･･変数の数
        'fmat(,)･･･係数行列
        'cvec()･･･右辺および解
        Dim aa$
        Dim i, ic, j, k, kk As Integer
        Dim b1, pivotvalue, valueb As Double

        kh = 0
        For k = 1 To nx
            ic = 0  'ﾋﾟﾎﾞｯﾄ有無のflag
            For i = k To nx  '0でないﾋﾟﾎﾞｯﾄを探索
                If fmat(i, k) <> 0 Then
                    ic = 1
                    kk = i
                    Exit For
                End If
            Next i
            If ic = 0 Then  'ｴﾗｰ処理
                kh = -1
                aa$ = "pivotvalue=0 AT k=" + Str$(k)
                aa$ = aa$ + Chr(13) + Chr(10) + "計算を終了させます！"
                MsgBox(aa$, 0, "計算エラー")
                Exit Sub
            End If

            pivotvalue = fmat(kk, k)
            If k = kk Then  'k行のﾋﾟﾎﾞｯﾄ割算
                For j = k To nx
                    fmat(k, j) = fmat(k, j) / pivotvalue
                Next j
                cvec(k) = cvec(k) / pivotvalue
            Else    'k行とkk行を入替え、ﾋﾟﾎﾞｯﾄ割算
                For j = k To nx
                    b1 = fmat(kk, j)
                    fmat(kk, j) = fmat(k, j)
                    fmat(k, j) = b1 / pivotvalue
                Next j
                b1 = cvec(kk)
                cvec(kk) = cvec(k)
                cvec(k) = b1 / pivotvalue
            End If

            For i = 1 To nx  'ﾋﾟﾎﾞｯﾄ以外の行を掃出し計算
                If i <> k Then
                    valueb = fmat(i, k)
                    If valueb <> 0 Then
                        For j = k To nx
                            fmat(i, j) = fmat(i, j) - valueb * fmat(k, j)
                        Next j
                        cvec(i) = cvec(i) - valueb * cvec(k)
                    End If
                End If
            Next i
        Next k

    End Sub

    Sub OptFileIn()
        'ｵﾌﾟｼｮﾝ･ﾌｧｲﾙ読み込み
        'UTF-8･･･BOMなし
        Dim ftmp$

        ftmp$ = DirOpen$ + "\LineEqMenu.tmp"
        Try
            Dim sr As New IO.StreamReader(ftmp$)
            KdataBackup = Val(sr.ReadLine)
            sr.Close()
        Catch
            '処理不要
        End Try

    End Sub

    Sub OptFileOut()
        'ｵﾌﾟｼｮﾝ･ﾌｧｲﾙ書き出し
        'UTF-8･･･BOMなし
        Dim ftmp$

        ftmp$ = DirOpen$ + "\LineEqMenu.tmp"
        Dim sw As New IO.StreamWriter(ftmp$)
        sw.WriteLine(KdataBackup)
        sw.Close()

    End Sub

    Sub PDoc_PrintPage(ByVal sender As System.Object, ByVal e As System.Drawing.Printing.PrintPageEventArgs)
        Dim linesPerPage As Integer
        Dim ypos As Single
        Dim ic, ncount As Integer
        Dim xleftMargin As Single
        Dim ytopMargin As Single
        Dim lineText$
        Dim printfont As Font = New Font("ＭＳ ゴシック", 10)

        linesPerPage = e.MarginBounds.Height / printfont.GetHeight(e.Graphics)
        ypos = 0
        ncount = 0
        xleftMargin = e.MarginBounds.Left
        ytopMargin = e.MarginBounds.Top

        ic = 0
        While ncount < linesPerPage
            If Kindex < Nline Then
                lineText$ = ArrText(Kindex)
                Kindex = Kindex + 1
            Else
                ic = 1
                Exit While
            End If
            ypos = ytopMargin + ncount * printfont.GetHeight(e.Graphics)
            e.Graphics.DrawString(lineText$, printfont, Brushes.Black, xleftMargin, ypos, New StringFormat())
            ncount = ncount + 1
        End While

        If ic = 0 And Kindex < Nline Then
            e.HasMorePages = True
        Else
            e.HasMorePages = False
        End If

    End Sub

    Sub TimCal(ByVal ktim As Integer, ByRef timn$)
        'ﾀｲﾏｰ計算
        'ktim･･･時間継続指定（0:時間ｸﾘｱする、1:時間継続する）
        'timn$･･･時分秒に換算した経過時間
        Dim rtime As Date = Now
        Dim rhour, rmin, sec As Single
        If ktim > 0 Then
            sec = DateDiff(DateInterval.Second, Timst, rtime)
            rhour = Int(sec / 3600) : sec = sec - rhour * 3600
            rmin = Int(sec / 60) : sec = Int(sec - rmin * 60)
            timn$ = Str$(rhour) + "h" + Str$(rmin) + "min" + Str$(sec) + "s"
        Else
            Timst = rtime
        End If
    End Sub

    Sub TmpFileIn()
        'ﾃﾝﾎﾟﾗﾘｰ･ﾌｧｲﾙ読み込み
        'UTF-8･･･BOMなし
        Dim ftmp$

        ftmp$ = DirOpen$ + "\LineEqua.tmp"
        Try
            Dim sr As New IO.StreamReader(ftmp$)
            Fm$ = sr.ReadLine
            Fy$ = sr.ReadLine
            sr.Close()
        Catch
            '処理不要
        End Try

    End Sub

    Sub TmpFileOut()
        'ﾃﾝﾎﾟﾗﾘｰ･ﾌｧｲﾙ書き出し
        'UTF-8･･･BOMなし
        Dim ftmp$

        ftmp$ = DirOpen$ + "\LineEqua.tmp"
        Dim sw As New IO.StreamWriter(ftmp$)
        sw.WriteLine(Fm$)
        sw.WriteLine(Fy$)
        sw.Close()

    End Sub

    Sub UFileAddA()
        'UFileAの追加処理
        Dim i, ic, j As Integer
        ic = 0
        For i = 2 To 6
            If UFileA(i) = UFileA(0) Then
                For j = i - 1 To 0 Step -1
                    UFileA(j + 1) = UFileA(j)
                Next j
                ic = 1
                Exit For
            End If
        Next i
        If ic = 0 Then
            For i = 5 To 0 Step -1
                UFileA(i + 1) = UFileA(i)
            Next i
        End If
        UseFileAOut()       'ﾃﾝﾎﾟﾗﾘｰ･ﾌｧｲﾙ書き出し

    End Sub

    Sub UseFileAIn()
        'ﾃﾝﾎﾟﾗﾘｰ･ﾌｧｲﾙ読み込み
        'UTF-8･･･BOMなし
        Dim ftmp$
        Dim i As Integer

        ftmp$ = DirOpen$ + "\LineEquaFileA.tmp"
        Try
            Dim sr As New IO.StreamReader(ftmp$)
            i = 0
            Do Until sr.Peek = -1 'ﾌｧｲﾙ末尾まで
                i = i + 1
                UFileA(i) = sr.ReadLine
            Loop
            sr.Close()
        Catch
            '処理不要
        End Try

    End Sub

    Sub UseFileAOut()
        'ﾃﾝﾎﾟﾗﾘｰ･ﾌｧｲﾙ書き出し
        'UTF-8･･･BOMなし
        Dim ftmp$
        Dim i As Integer

        ftmp$ = DirOpen$ + "\LineEquaFileA.tmp"
        Dim sw As New IO.StreamWriter(ftmp$)
        For i = 1 To 6
            If UFileA(i) <> "" Then
                sw.WriteLine(UFileA(i))
            Else
                Exit For
            End If
        Next i
        sw.Close()

    End Sub

End Module
