'常微分方程式のRKG法ｿﾙﾊﾞｰV8の標準ﾓｼﾞｭｰﾙ   ［作成］黒田英夫(2023/04)
Imports System.Drawing.Printing

Module OrdDiffCom

    'V2での改良点・・・入力データファイルの先頭にプログラム名を追加
    '                  （データの読み違いを防止）
    'V3での改良点・・・実行形式をDebugモードからReleaseモードへ変更
    '                   （計算時間の大幅短縮）
    'V4での改良点・・・各画面でボタンを読みやすい色に改善
    'V5での改良点・・・Visual Basic 2017に変更
    'V6での改良点・・・プログラムファイルの文字コードをUTF-8に統一、
    '                  データファイルの文字コードをUTF-8に変更
    'V7での改良点・・・入力データのファイル印刷メニューを廃止
    '                  （文字コードによる不具合のため）
    'V8での改良点・・・フリーソフト化、VB2022に移行

    Public CalcRes$             '計算結果表示データ
    Public DirOpen$             '立ち上げ時のディレクトリー名
    Public Fm$                  '入力データのファイル名
    Public Fy$                  '計算結果のファイル名
    Public Title$               'タイトル

    Public Timst As Date        '計算開始時刻

    Public InOut As Integer     'ファイル入出力の種類（0:入力、1:出力）
    Public KdataBackup As Integer   '入力データのバックアップファイル作成（0:なし、1:有り）
    Public KdataChange As Integer   'データ変更の有無（0:なし、1:有り）
    Public Kindex As Integer    'ﾃｷｽﾄｱﾚｲのｲﾝﾃﾞｯｸｽ
    Public KnewUFileA As Integer    '最近使用ﾌｧｲﾙAの更新有無
    Public N As Integer         'Xの次数
    Public Ndiv As Integer      'X範囲の分割数
    Public Nline As Integer     'ﾌｧｲﾙの行数

    Public XL As Single         'Xの最小値
    Public XU As Single         'Xの最大値
    Public Y0 As Single         'X最小値における微分値

    Public ArrText As New ArrayList()

    Public UFileA(6) As String  '最近使用した入力ﾌｧｲﾙの保存配列

    Public A() As Single        'X項の係数
    Public B(2) As Single       'XY、Y、Y^2の係数

    Sub DfileInputU(ByVal fxx$)
        '入力ﾃﾞｰﾀﾌｧｲﾙの読み込み
        'UTF-8･･･BOMなし
        'fxx$･･･入力ﾌｧｲﾙ名
        Dim aa$
        Dim i As Integer

        Dim sr As New System.IO.StreamReader(fxx$)
        Dim dat() As String
        aa$ = sr.ReadLine
        dat = aa.Split(",")
        aa$ = dat(1)
        If aa$ <> "OrdDiffEqua" Then
            aa$ = "データファイルが違います！"
            MsgBox(aa$, 0, "データエラー")
            sr.Close()
            Exit Sub
        End If
        Title$ = sr.ReadLine
        aa$ = sr.ReadLine
        dat = aa.Split(",")
        N = dat(1)
        ReDim A(N)

        aa$ = sr.ReadLine
        aa$ = sr.ReadLine
        For i = 0 To N
            aa$ = sr.ReadLine
            dat = aa.Split(",")
            A(i) = dat(1)
        Next i
        For i = 0 To 2
            aa$ = sr.ReadLine
            dat = aa.Split(",")
            B(i) = dat(1)
        Next i
        sr.Close()

    End Sub

    Sub DfileOutU(ByVal fxx$)
        '入力ﾃﾞｰﾀﾌｧｲﾙへの書き出し
        'UTF-8･･･BOMなし
        'fxx$･･･入力ﾃﾞｰﾀﾌｧｲﾙ名
        Dim aa$
        Dim i As Integer

        Dim sw As New IO.StreamWriter(fxx$)
        aa$ = "プログラム名" + "," + "OrdDiffEqua"
        sw.WriteLine(aa$)
        sw.WriteLine(Title$)
        aa$ = "常微分方程式の次数" + "," + Str(N)
        sw.WriteLine(aa$)

        sw.WriteLine("＜常微分方程式データ＞")
        sw.WriteLine("係数名、係数値")
        For i = 0 To N
            aa$ = "a" + LTrim(Str(i))
            aa$ = aa$ + ",   " + Str(A(i))
            sw.WriteLine(aa$)
        Next i
        For i = 0 To 2
            aa$ = "b" + LTrim(Str(i))
            aa$ = aa$ + ",   " + Str(B(i))
            sw.WriteLine(aa$)
        Next i
        sw.Close()
        aa$ = "データをファイルへ保存しました。"
        MsgBox(aa$, 0, "ファイル保存完了")

    End Sub

    Function EquaValue(ByVal xb As Single, ByVal yb As Single) As Single
        '１元高次方程式の関数値
        'xb,yb･･･変数X,Y
        Dim i As Integer
        Dim b1 As Single

        b1 = A(0)
        For i = 1 To N
            b1 = b1 + A(i) * xb ^ i
        Next i
        b1 = b1 + B(0) * xb * yb
        For i = 1 To 2
            b1 = b1 + B(i) * yb ^ i
        Next
        Return b1

    End Function

    Sub FileName(ByRef fxx$, ByRef fxb$)
        'ﾌｧｲﾙ名fxx$の拡張子なしの部分fxb$を取り出す
        Dim i As Integer
        i = InStr(fxx$, ".")
        If i > 0 Then
            fxb$ = Left$(fxx$, i - 1)
        Else
            fxb$ = fxx$
        End If
    End Sub

    Sub OptFileIn()
        'ｵﾌﾟｼｮﾝ･ﾌｧｲﾙ読み込み
        'UTF-8･･･BOMなし
        Dim ftmp$

        ftmp$ = DirOpen$ + "\OrdDiffMenu.tmp"
        Try
            Dim sr As New IO.StreamReader(ftmp$)
            KdataBackup = Val(sr.ReadLine)
            sr.Close()
        Catch
            '処理不要
        End Try

    End Sub

    Sub OptFileOut()
        'ｵﾌﾟｼｮﾝ･ﾌｧｲﾙ書き出し
        'UTF-8･･･BOMなし
        Dim ftmp$

        ftmp$ = DirOpen$ + "\OrdDiffMenu.tmp"
        Dim sw As New IO.StreamWriter(ftmp$)
        sw.WriteLine(KdataBackup)
        sw.Close()

    End Sub

    Sub PDoc_PrintPage(ByVal sender As System.Object, ByVal e As System.Drawing.Printing.PrintPageEventArgs)
        Dim linesPerPage As Integer
        Dim ypos As Single
        Dim ic, ncount As Integer
        Dim xleftMargin As Single
        Dim ytopMargin As Single
        Dim lineText$
        Dim printfont As Font = New Font("ＭＳ ゴシック", 10)

        linesPerPage = e.MarginBounds.Height / printfont.GetHeight(e.Graphics)
        ypos = 0
        ncount = 0
        xleftMargin = e.MarginBounds.Left
        ytopMargin = e.MarginBounds.Top

        ic = 0
        While ncount < linesPerPage
            If Kindex < Nline Then
                lineText$ = ArrText(Kindex)
                Kindex = Kindex + 1
            Else
                ic = 1
                Exit While
            End If
            ypos = ytopMargin + ncount * printfont.GetHeight(e.Graphics)
            e.Graphics.DrawString(lineText$, printfont, Brushes.Black, xleftMargin, ypos, New StringFormat())
            ncount = ncount + 1
        End While

        If ic = 0 And Kindex < Nline Then
            e.HasMorePages = True
        Else
            e.HasMorePages = False
        End If

    End Sub

    Sub RKGsolver(ByVal h As Single, ByRef q As Single, _
    ByVal xb As Single, ByRef yb As Single)
        'Runge Kutta Gill法
        'h･･･刻み
        'q･･･RKG法の変数q
        'xb･･･X値
        'yb･･･Y値
        Dim b1, c1, eta, rk, rr, xx As Single

        c1 = Math.Sqrt(0.5)

        b1 = EquaValue(xb, yb)
        rk = h * b1
        rr = 0.5 * (rk - 2 * q)
        eta = yb + rr
        q = q + 3 * rr - 0.5 * rk
        xx = xb + 0.5 * h
        b1 = EquaValue(xx, eta)
        rk = h * b1
        rr = (1 - c1) * (rk - q)
        eta = eta + rr
        q = q + 3 * rr - (1 - c1) * rk
        b1 = EquaValue(xx, eta)
        rk = h * b1
        rr = (1 + c1) * (rk - q)
        eta = eta + rr
        q = q + 3 * rr - (1 + c1) * rk
        xx = xb + h
        b1 = EquaValue(xx, eta)
        rk = h * b1
        rr = (rk - 2 * q) / 6
        eta = eta + rr
        q = q + 3 * rr - 0.5 * rk

        yb = eta

    End Sub

    Sub TimCal(ByVal ktim As Integer, ByRef timn$)
        'ﾀｲﾏｰ計算
        'ktim･･･時間継続指定（0:時間ｸﾘｱする、1:時間継続する）
        'timn$･･･時分秒に換算した経過時間
        Dim rtime As Date = Now
        Dim rhour, rmin, sec As Single
        If ktim > 0 Then
            sec = DateDiff(DateInterval.Second, Timst, rtime)
            rhour = Int(sec / 3600) : sec = sec - rhour * 3600
            rmin = Int(sec / 60) : sec = Int(sec - rmin * 60)
            timn$ = Str$(rhour) + "h" + Str$(rmin) + "min" + Str$(sec) + "s"
        Else
            Timst = rtime
        End If
    End Sub

    Sub TmpFileIn()
        'ﾃﾝﾎﾟﾗﾘｰ･ﾌｧｲﾙ読み込み
        'UTF-8･･･BOMなし
        Dim ftmp$

        ftmp$ = DirOpen$ + "\OrdDiffEqua.tmp"
        Try
            Dim sr As New IO.StreamReader(ftmp$)
            Fm$ = sr.ReadLine
            Fy$ = sr.ReadLine
            sr.Close()
        Catch
            '処理不要
        End Try

    End Sub

    Sub TmpFileOut()
        'ﾃﾝﾎﾟﾗﾘｰ･ﾌｧｲﾙ書き出し
        'UTF-8･･･BOMなし
        Dim ftmp$

        ftmp$ = DirOpen$ + "\OrdDiffEqua.tmp"
        Dim sw As New IO.StreamWriter(ftmp$)
        sw.WriteLine(Fm$)
        sw.WriteLine(Fy$)
        sw.Close()

    End Sub

    Sub UFileAddA()
        'UFileAの追加処理
        Dim i, ic, j As Integer
        ic = 0
        For i = 2 To 6
            If UFileA(i) = UFileA(0) Then
                For j = i - 1 To 0 Step -1
                    UFileA(j + 1) = UFileA(j)
                Next j
                ic = 1
                Exit For
            End If
        Next i
        If ic = 0 Then
            For i = 5 To 0 Step -1
                UFileA(i + 1) = UFileA(i)
            Next i
        End If
        UseFileAOut()       'ﾃﾝﾎﾟﾗﾘｰ･ﾌｧｲﾙ書き出し

    End Sub

    Sub UseFileAIn()
        'ﾃﾝﾎﾟﾗﾘｰ･ﾌｧｲﾙ読み込み
        Dim ftmp$
        Dim i As Integer

        ftmp$ = DirOpen$ + "\OrdDiffFileA.tmp"
        Try
            Dim sr As New IO.StreamReader(ftmp$)
            i = 0
            Do Until sr.Peek = -1 'ﾌｧｲﾙ末尾まで
                i = i + 1
                UFileA(i) = sr.ReadLine
            Loop
            sr.Close()
        Catch
            '処理不要
        End Try

    End Sub

    Sub UseFileAOut()
        'ﾃﾝﾎﾟﾗﾘｰ･ﾌｧｲﾙ書き出し
        Dim ftmp$
        Dim i As Integer

        ftmp$ = DirOpen$ + "\OrdDiffFileA.tmp"
        Dim sw As New IO.StreamWriter(ftmp$)
        For i = 1 To 6
            If UFileA(i) <> "" Then
                sw.WriteLine(UFileA(i))
            Else
                Exit For
            End If
        Next i
        sw.Close()

    End Sub

End Module
